# This file is part of Lanradio.
#
# Lanradio is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Lanradio is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with Lanradio.  If not, see <http://www.gnu.org/licenses/>.
#
# Authors:
# Florian Klingler <klingler@ccs-labs.org>

#!/bin/sh

# downloads
# http://oldforge.etsi.org/websvn/dl.php?repname=ITS.ITS_ASN1&path=%2Ftrunk%2FCDD_TS102894-2%2FITS-Container.asn&rev=18&peg=18
# http://oldforge.etsi.org/websvn/dl.php?repname=ITS.ITS_ASN1&path=%2Ftrunk%2FCAM_EN302637-2%2FCAM.asn&rev=2&peg=2
# http://oldforge.etsi.org/websvn/dl.php?repname=ITS.ITS_ASN1&path=%2Ftrunk%2FDENM_EN302637-3%2FDENM.asn&rev=5&peg=5
# http://oldforge.etsi.org/websvn/dl.php?repname=ITS.ITS_ASN1&path=%2Ftags%2FMAP_SPAT_SAEJ2735%2F20141020%2FDSRC_REG_D.asn&rev=9&peg=9
# http://oldforge.etsi.org/websvn/dl.php?repname=ITS.ITS_ASN1&path=%2Ftags%2FMAP_SPAT_SAEJ2735%2F20141020%2FMAP_SPAT_ETSI.asn&rev=9&peg=9
# http://oldforge.etsi.org/websvn/dl.php?repname=ITS.ITS_ASN1&path=%2Ftags%2FMAP_SPAT_SAEJ2735%2F20141020%2FMAP_SPAT_REG_D.asn&rev=9&peg=9
#

set -x

#include trailing slash!
asn1_install_dir=/home/klingler/software/tmp/asn1c/

mkdir -p build
cd build

rm *.cc *.h *.c Makefile.am.sample
$asn1_install_dir/bin/asn1c -fnative-types -gen-PER -pdu=auto ../*.asn

set -e
#find . -type l | xargs rm 

cp $asn1_install_dir/share/asn1c/*.c .
cp $asn1_install_dir/share/asn1c/*.h .
rm converter-sample.c
sed -i 's/#include </#include \"/g' *.h
sed -i 's/.h>/.h\"/g' *.h
sed -i 's/#include </#include \"/g' *.c
sed -i 's/.h>/.h\"/g' *.c

sed -i 's/APC_UNCONSTRAINED/asn_per_constraint_s\:\:asn_per_constraint_flags\:\:APC_UNCONSTRAINED/g' *.c
sed -i 's/APC_SEMI_CONSTRAINED/asn_per_constraint_s\:\:asn_per_constraint_flags\:\:APC_SEMI_CONSTRAINED/g' *.c
sed -i 's/APC_CONSTRAINED/asn_per_constraint_s\:\:asn_per_constraint_flags\:\:APC_CONSTRAINED/g' *.c
sed -i 's/APC_EXTENSIBLE/asn_per_constraint_s\:\:asn_per_constraint_flags\:\:APC_EXTENSIBLE/g' *.c


sed -i 's/ASN_OSUBV_ANY/asn_OCTET_STRING_specifics_s\:\:asn_OS_Subvariant\:\:ASN_OSUBV_ANY/g' *.c
sed -i 's/ASN_OSUBV_BIT/asn_OCTET_STRING_specifics_s\:\:asn_OS_Subvariant\:\:ASN_OSUBV_BIT/g' *.c
sed -i 's/ASN_OSUBV_STR/asn_OCTET_STRING_specifics_s\:\:asn_OS_Subvariant\:\:ASN_OSUBV_STR/g' *.c
sed -i 's/ASN_OSUBV_U16/asn_OCTET_STRING_specifics_s\:\:asn_OS_Subvariant\:\:ASN_OSUBV_U16/g' *.c
sed -i 's/ASN_OSUBV_U32/asn_OCTET_STRING_specifics_s\:\:asn_OS_Subvariant\:\:ASN_OSUBV_U32/g' *.c

sed -i 's/asn_OS_Subvariant/asn_OCTET_STRING_specifics_s\:\:asn_OS_Subvariant/g' *.c

sed -i 's/struct\ offsetXaxis/struct\ ComputedLane\:\:offsetXaxis/g' ComputedLane.c
sed -i 's/struct\ offsetYaxis/struct\ ComputedLane\:\:offsetYaxis/g' ComputedLane.c

for f in *.c; do 
mv -- "$f" "${f%.c}.cc"
done
